//MODIFICACIONES BACKOFFICE (PANEL ADMINISTRACIÓN)

//Inserción de nueva pestaña correspondiente a los motivos de devolución

INSERT INTO ps_tab (id_tab,id_parent,class_name,module,position)
       VALUES      ( 95, 3,'AdminMotivDevol',NULL, 4);

//Operaciones permitidas en la pestaña
INSERT INTO ps_access (`id_profile`,`id_tab`, `view`, `add`,`edit`,`delete`)
         VALUES         ( 1,95,1,1,1,1); 

//Definición de la pestanya en inglés, castellano y catalán
INSERT INTO ps_tab_lang (id_tab,id_lang,name)
       VALUES           ( 95,1,'Return States' );
INSERT INTO ps_tab_lang (id_tab,id_lang,name)
       VALUES           ( 95,3,'Estados Devolución' );
INSERT INTO ps_tab_lang (id_tab,id_lang,name)
       VALUES           ( 95,6,'Estats Devolució' );

//Creación de las tablas para almacenar los motivos de las devoluciones

CREATE TABLE ps_order_return_motive (
  id_order_return_motive int(10) unsigned NOT NULL AUTO_INCREMENT,
  color varchar(32) DEFAULT NULL,
  PRIMARY KEY (id_order_return_motive)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=8 ;

CREATE TABLE ps_order_return_motive_lang (
  id_order_return_motive int(10) unsigned NOT NULL,
  id_lang int(10) unsigned NOT NULL,
  `name` varchar(64) NOT NULL,
  UNIQUE KEY order_motive_lang_index (id_order_return_motive,id_lang)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

//Creación de las tablas para almacenar los estados por los que pasará una devolución

CREATE TABLE ps_order_return_state (
  id_order_return_state int(10) unsigned NOT NULL AUTO_INCREMENT,
  color varchar(32) DEFAULT NULL,
  PRIMARY KEY (id_order_return_state)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=6 ;


CREATE TABLE ps_order_return_state_lang (
  id_order_return_state int(10) unsigned NOT NULL,
  id_lang int(10) unsigned NOT NULL,
  `name` varchar(64) NOT NULL,
  UNIQUE KEY order_state_lang_index (id_order_return_state,id_lang)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


//MODIFICACIONES FRONTOFFICE 

//Añadimos campos en las tablas referentes a las devoluciones
//Añadimos a la tabla ps_order_return campos para almacenar el transportista que se encargará de la devolución, el motivo, el total a devolver y el núm de cuenta del cliente

alter table ps_order_return add column transportista varchar(50)
alter table ps_order_return add column id_order_return_motive varchar(25)
alter table ps_order_return add column total_paid float
alter table ps_order_return add column num_cuenta varchar(20)

//Añadimos a la tabla ps_order_return_detail qué item devuelve, qué cantidad y el coste de esa línea de detalle

alter table ps_order_return_detail add column item varchar(50)
alter table ps_order_return_detail add column quantity int
alter table ps_order_return_detail add column amount decimal(8,2)

//Creamos la tabla ps_nacex_pedidos_devolucion donde almacenaremos datos de la devolución para enviar el correo al transportista con la información que necesita

CREATE TABLE ps_nacex_pedidos_devolucion (
  id_order_return int(10) unsigned NOT NULL,
  hora_recogida varchar(50) DEFAULT NULL,
  id_cliente int(10),
  direccion_recogida varchar(50),
  codigo_postal varchar(5),
  ciudad varchar(50),
  provincia varchar(50),
  entrega_en_agencia varchar(1),
  cliente_agencia varchar(10),
  PRIMARY KEY (id_order_return)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=8 ;


