<?php
/*
* 2007-2011 PrestaShop 
*
* NOTICE OF LICENSE
*
* This source file is subject to the Open Software License (OSL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/osl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2011 PrestaShop SA
*  @version  Release: $Revision: 7540 $
*  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/

class Motivos extends ObjectModel
{
 	/** @var string Name */
	public 		$name;
	
	protected 	$fieldsRequiredLang = array('name');
 	protected 	$fieldsSizeLang = array('name' => 64, 'template' => 64);
 	protected 	$fieldsValidateLang = array('name' => 'isGenericName', 'template' => 'isTplName');
	
	protected 	$table = 'order_return_motive';
	protected 	$identifier = 'id_order_return_motive';
	
	
	
	public function getFields()
	{
	}
	
	/**
	* Check then return multilingual fields for database interaction
	*
	* @return array Multilingual fields
	*/
	public function getTranslationsFieldsChild()
	{
		parent::validateFieldsLang();
		return parent::getTranslationsFields(array('name', 'template'));
	}
	
	/**
	* Get all available order states
	*
	* @return array Order Motives
	*/
	public static function getOrderMotives($id_lang)
	{
		static $miSQL;
		//Motivos
		$miSQL = "SELECT os.id_order_return_motive, `name` miNombre FROM ps_order_return_motive os
			LEFT JOIN ps_order_return_motive_lang osl ON (os.id_order_return_motive = osl.id_order_return_motive 
			AND osl.id_lang = ".$id_lang." ) ORDER BY 1 ASC";
	
		$valorDevuelto = Db::getInstance()->ExecuteS($miSQL);
		return $valorDevuelto;

	}

	//Pedido ya devuelto, calculamos los items que quedan
	public static function getquantity($id_order)
	{
		static $miSQL;
	
		$miSQL = "SELECT SUM(product_quantity- product_quantity_refunded) FROM `ps_order_detail` WHERE id_order= ".$id_order."  ORDER BY 1 ASC";

		$valorDevuelto = Db::getInstance()->getValue($miSQL);
		
		return $valorDevuelto;

	}

	//descripcion del motivo
	public static function getOrderMotivesDesc($id_lang, $id_order_return_motive)
	{
		static $miSQL;
		$miSQL = "SELECT  `name` miNombre FROM ps_order_return_motive os
			INNER JOIN ps_order_return_motive_lang osl ON (os.id_order_return_motive = osl.id_order_return_motive 
			AND osl.id_lang = ".$id_lang."  and os.id_order_return_motive=".$id_order_return_motive.") ORDER BY 1 ASC";
		
		$valorDevuelto = Db::getInstance()->getValue($miSQL);
		return $valorDevuelto;

	}
	
	//leemos de las variables del backoffice y vemos si hay o no coste en la devolución del pedido
	public static function getGastosDevolucion($id_order)
	{
		static $miSQL;

		$miSQL = "SELECT os.total_paid from ps_orders os
			where os.id_order = ".$id_order."  ORDER BY 1 ASC";
		
		$valorDevuelto = Db::getInstance()->getRow($miSQL);
		$v=$valorDevuelto['total_paid'];

		//recuperamos ahora el importe máximo para que la devolución sea gratuita
		$compragrat = (int)Configuration::get('PS_ORDER_RETURN_FREE');
	
		//Coste en caso de que la devolución no sea gratuita
		$costedev = (int)Configuration::get('PS_ORDER_RETURN_COST');
	
		if ($v < $compragrat){
			$mensajeCoste="Devolución con Coste de ".$costedev." €";
		}
		else{
			$mensajeCoste="Costes Devolución Gratuitos";
		}

		return $mensajeCoste;
	}

	//importe a cobrar de gastos
	public static function getimporteDevolucion($id_order)
	{
		static $miSQL;

		$miSQL = "SELECT os.total_paid from ps_orders os
			where os.id_order = ".$id_order."  ORDER BY 1 ASC";
		$valorDevuelto = Db::getInstance()->getRow($miSQL);

		$v=$valorDevuelto['total_paid'];

		//recuperamos ahora el importe máximo para que la devolución sea gratuita
		$compragrat = (int)Configuration::get('PS_ORDER_RETURN_FREE');

		//Coste en caso de que la devolución no sea gratuita
		$costedev = (int)Configuration::get('PS_ORDER_RETURN_COST');

		if ($v < $compragrat){
			$importeDev=$costedev;
		}
		else{
		$importeDev="0";
		}

		return $importeDev;

	}

	//direcciones del cliente donde para que aparezcan en el desplegable
	public static function getDirecDevol($id_customer)
	{
		static $miSQL;
	
		$miSQL = "SELECT os.id_address, os.alias from ps_address os where os.id_customer = ".$id_customer."  ORDER BY 1 ASC";
			
		
		$valorDevuelto = Db::getInstance()->ExecuteS($miSQL);
		return $valorDevuelto;

	}

	//Obtener la descripcion de la dirección de envío
	public static function getDescripDirecDevol($direcDevol)
	{
		static $miSQL;
		
		$miSQL = "SELECT os.address1, os.postcode, os.city from ps_address os where os.id_address = ".$direcDevol."  ORDER BY 1 ASC";
		$valorDevuelto = Db::getInstance()->ExecuteS($miSQL);
		return $valorDevuelto;

	}

	//Obtener la descripcion del item/s devuelto/s
	public static function getDescripItemDev($id_order_detail)
	{
		static $miSQL;

		$miSQL = "SELECT od.product_name, od.product_price from ps_order_detail od where od.id_order_detail = ".$id_order_detail."  ORDER BY 1 ASC";
 
		$valorDevuelto = Db::getInstance()->getRow($miSQL);

		return $valorDevuelto;

	}

	//obtenemos el metodo con el que se ha pagado el pedido
	public static function getMetodoPago($id_order)
	{
		static $miSQL;

		$miSQL = "SELECT od.payment from ps_orders od where od.id_order = ".$id_order."  ORDER BY 1 ASC";
 
		$valorDevuelto = Db::getInstance()->getRow($miSQL);
		$v=$valorDevuelto['payment'];

		return $v;
	}

	public static function getTodasDirec($id_customer)
	{
		static $miSQL;

		//obtenemos todas las direcciones que el cliente tiene registradas para que escoja donde se recogerá la devolución del pedido
		$miSQL = "SELECT pa.alias as Alias, pa.lastname as Apellidos, pa.firstname as Nombre, pa.address1 as Direccion, pa.postcode as CP, pa.city as Ciudad,pcl.name as Pais
		FROM ps_address pa
		INNER JOIN ps_country_lang pcl ON pa.id_country = pcl.id_country
		INNER JOIN ps_state ps ON pa.id_state = ps.id_state
		WHERE pa.id_customer = ".$id_customer." and pcl.id_lang='3'";

		$valorDevuelto = Db::getInstance()->ExecuteS($miSQL);
		return $valorDevuelto;

	}
	
	//obtenemos el transportista que debe llevar a cabo la devolución
	public static function getTransportistaDevol($id_customer)
	{
		static $miSQL;
		

		//A partir de la provincia y el pais devolvemos qué transportista será el encargado de recoger nuestra devolución
		$miSQL = "SELECT os.id_country id_pais, os.id_state id_provincia, cl.name pais, ps.name estado from ps_address os inner join ps_country_lang cl on os.id_country=cl.id_country inner join ps_state ps on os.id_state=ps.id_state where os.id_customer = ".$id_customer." and cl.id_lang='3'";

		$valorDevuelto = Db::getInstance()->ExecuteS($miSQL);
		$arrayProvincias = array();
		array_push($arrayProvincias, '133', '134','135','136','143','160','171','172');

		//Si son las islas, Melilla, Ceuta o Andorra se realizará por correo
		if ((($valorDevuelto['0']['id_pais']) == '40') or 
		((($valorDevuelto['0']['id_pais']) == '6') and (in_array($valorDevuelto['0']['id_provincia'], $arrayProvincias, true))))
		{
			$transportista='Correos';
		}//Si el país es España (peninsula o Portugal NACEX)
		elseif ((($valorDevuelto['0']['id_pais']) == '6') or (($valorDevuelto['0']['id_pais']) == '15'))
		{
			$transportista='NACEX';
		}
		else {
		//resto de paises
			$transportista='Transportista por cuenta del cliente';
		}

		return $transportista;

		}

	
	
	public function isRemovable()
	{
	 	return !($this->unremovable);
	}
}



