<?php
/*
* 2007-2011 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Open Software License (OSL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/osl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2011 PrestaShop SA
*  @version  Release: $Revision: 7854 $
*  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/


class itemsdevueltosControllerReturnCore extends FrontController
{
	public $auth = true;
	public $authRedirection = 'order-detail-return.php';
	public $ssl = true;
	
	public function __construct()
	{
		parent::__construct();

		header("Cache-Control: no-cache, must-revalidate");
		header("Expires: Sat, 26 Jul 1997 05:00:00 GMT");
	}

	public function preProcess()
	{
		parent::preProcess();

		$horarecogida= $_COOKIE["hora_recogidacookie"];
		$idOrder = $_COOKIE["id_ordercookie"];
		$motivo= $_COOKIE["motivocookie"];
		$idEnvio=$_COOKIE["id_enviocookie"];
		$direcDevol=$_COOKIE["direcDevolcookie"];
		$cantidad=$_COOKIE["arrayCantidadcookie"];
		$idDevolucion=$_COOKIE["arrayValoresID"];
		$cliente=$_COOKIE["clientecookie"];
		$numCuenta=$_COOKIE["numCuentacookie"];
		$importeDev=$_COOKIE["importeDevcookie"];

		//vemos si hay que enviar correo a Nacex para que recoja el paquete o no
		if($idEnvio=='false'){
			$correoNacex='S';
		}
		else{
			$correoNacex='N';
		}
		//recuperamos las cookies de la pantalla anterior y las asignamos a la pantalla de presentación de datos
		$descMotivo= Motivos::getOrderMotivesDesc('3', $motivo);
		$pago=$_COOKIE["pagocookie"];
		self::$smarty->assign('idOrder', $idOrder);

		self::$smarty->assign('horarecogida', $horarecogida);
		self::$smarty->assign('motivo', $descMotivo);
		self::$smarty->assign('pago', $pago);
		self::$smarty->assign('numCuenta', $numCuenta);
		//si el cliente es de peninsula y lo lleva a las oficionas de nacex
		if ($idEnvio =true){
			self::$smarty->assign('idEnvio', 'Lo llevará a las oficinas de NACEX');
		}
		//si nacex pasa a recogerlo
		if ($direcDevol !=0){
			$descDirecDevol= Motivos:: getDescripDirecDevol($direcDevol);
			$calle=$descDirecDevol[0]['address1'];
			$postcode=$descDirecDevol[0]['postcode'];
			$city=$descDirecDevol[0]['city'];
			self::$smarty->assign('calle', $calle);
			self::$smarty->assign('postcode', $postcode);
			self::$smarty->assign('city', $city);
		}
		//rellenamos los items a devolver y la cantidad de ellos
		$idDevolucion = substr($idDevolucion, 1);
		$idDevolucionFormat=explode('_', $idDevolucion);
		$totalDev=0;
		$cantidad = substr($cantidad, 1);
		$cantidadFormat = explode('_', $cantidad);

		$arrayItem = array();
		$arrayNombre = array();
		$arrayPrecio = array();
		$arrayCantidad = array();
		$arrayPrecioTotal= array();
		for($i=0;$i<count($idDevolucionFormat);$i++){
    			$nombreProd= Motivos::getDescripItemDev($idDevolucionFormat[$i]);
   			array_push($arrayItem,$i);
    			array_push($arrayNombre,$nombreProd['product_name']);
    			$nombreProd['product_price']=round($nombreProd['product_price'],2);
   			array_push($arrayPrecio,$nombreProd['product_price']);
    			precio_total=$arrayPrecio[$i]*$cantidadFormat[$i];
    			$precio_total=round($precio_total,2);
    			$totalDev= $totalDev+$precio_total;
    			array_push($arrayPrecioTotal,$precio_total);
    			array_push($arrayCantidad,$cantidadFormat[$i]);	
		};
		//asignamos los valores a la pantalla de presentacion de datos
		self::$smarty->assign('numProds',count($idDevolucionFormat));
		self::$smarty->assign('arrayItem',$arrayItem);
		self::$smarty->assign('arrayNombre',$arrayNombre);
		self::$smarty->assign('arrayPrecio',$arrayPrecio);
		self::$smarty->assign('arrayCantidad',$arrayCantidad);
		self::$smarty->assign('arrayPrecioTotal',$arrayPrecioTotal);
		//Si se le cobran gastos de devolución habría que restarlos del importe total a devolver
		$totalDev=Round($totalDev, 2);
		$importeDev= Round($importeDev,2);
		$totalDev=$totalDev-$importeDev;

		self::$smarty->assign('importeDev',$importeDev);
		self::$smarty->assign('totalDev',$totalDev);
		self::$smarty->assign('cliente',$cliente);


		$transportista= Motivos::getTransportistaDevol($cliente);

		self::$smarty->assign('transportista',$transportista);

		self::$smarty->assign('cantidad', $cantidad);
		$arrayParamcantidad = explode('_', $cantidad);

		self::$smarty->assign('descriProd', $descriProd);
		self::$smarty->assign('precioProd', $precioProd);
		self::$smarty->assign('idDevolucion', $idDevolucion);

		$estado="introducido";
		$customization= 0;
		//hay que insertar en ps_order_return y en ps_order_return_detail. En caso de que la devolución la haga Nacex insertaremos en ps_Nacex_pedidos_devolucion
		$miSQL1 = "INSERT INTO ps_order_return  ";
		$miSQL2 = " (id_customer, id_order,  id_order_return_motive,  transportista, payment, num_cuenta, date_add, date_upd) ";
		$miSQL3 = " VALUES (".$cliente.",".$idOrder.",'".$descMotivo."','".$transportista."','".$pago."','".$numCuenta."', NOW(), NOW()) ";
		
		$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3;
		Db::getInstance()->execute($miSQL);
		//leemos el id_order_return que acabamos de insertar
		$miSQL4="SELECT MAX(id_order_return) as numDevol FROM ps_order_return";
		$valorMaximo = Db::getInstance()->getRow($miSQL4);
		$id_devolucion=$valorMaximo['numDevol'];


		//ahora insertamos el detalle del pedido devuelto
		for($i=0;$i<count($idDevolucionFormat);$i++){

		$miSQL5 = "INSERT INTO ps_order_return_detail  ";
		$miSQL6 = " (id_order_return, id_order_detail,id_customization, item,  quantity, amount, product_quantity) ";
		$miSQL7 = " VALUES (".$id_devolucion.",".$idDevolucionFormat[$i]." ,".$customization.", '".$arrayNombre[$i]."', ".$cantidadFormat[$i].",".$arrayPrecio[$i].", ".$cantidadFormat[$i]." ) ";
		
		$miSQL  = $miSQL5." ".$miSQL6." ".$miSQL7;
		Db::getInstance()->execute($miSQL);

		//Actualizar la tabla de pedidos marcando los items que se han devuelto
		$miSQL8 = "UPDATE ps_order_detail set product_quantity_refunded= product_quantity_refunded +".$cantidadFormat[$i]." where id_order_detail=".$idDevolucionFormat[$i]." ";
		Db::getInstance()->execute($miSQL8);
		};
		
		//Si el transportista es NACEX debemos insertar en la tabla los datos para poder enviarle un correo directamente a Nacex y que sepa que tiene que ir a recoger el pedido a la hora 			insertada en el lugar que se le dice

		self::$smarty->assign('id_devolucion', $id_devolucion);

		if ($transportista =="NACEX"){
		//vemos si el cliente lleva el pedido a la agencia él mismo
			if($correoNacex=='N'){
				$cliente_agencia="0848.3253";
				$calle="";
				$postcode="";
				$city="";
				$provincia="";
				}
			else{
				//Obtenemos los datos de la dir de devolucion
				$calle=$descDirecDevol[0]['address1'];
				$postcode=$descDirecDevol[0]['postcode'];
				$city=$descDirecDevol[0]['city'];
			}
		$miSQL10 = "INSERT INTO ps_nacex_pedidos_devolucion  ";
		$miSQL11 = " (id_order_return,hora_recogida, id_cliente,direccion_recogida, codigo_postal,ciudad,provincia,entrega_en_agencia,cliente_agencia) ";
		$miSQL12 = " VALUES (".$id_devolucion.",'".$horarecogida."' ,".$cliente.", '".$calle."','".$postcode."','".$city."','".$provincia."','".$idEnvio."', '".$cliente_agencia."' ) ";
		
		$miSQL  = $miSQL10." ".$miSQL11." ".$miSQL12;
		Db::getInstance()->execute($miSQL);


		}
		//Envio de correo
		// obtener datos del cliente 
			$miSQL1 = "SELECT firstname, lastname, email ";
			$miSQL2 = "FROM  ps_customer  ";
			$miSQL3 = "WHERE id_customer = ". $cliente ." ";
			$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3;
			$valores = Db::getInstance()->getRow($miSQL);
			$firstname = $valores['firstname'];
			$lastname = $valores['lastname'];
			$email = $valores['email'];


			$fecha= date("j/m/Y, g:i a");
			$totalProd= $totalDev+$importeDev;

			$tablaProductosHTML = '';
			$tablaProductosTXT = '';
			for($i=0;$i<count($idDevolucionFormat);$i++){

				$precioTot=$cantidadFormat[$i]*$arrayPrecio[$i];

				$tablaProductosHTML = $tablaProductosHTML .'<tr style="text-align: center;"><td width: 70%; colspan="2">'.$arrayNombre[$i] .'</td><td text-align: center; width: 10%;>'.$cantidadFormat[$i].'</td><td text-align: right; width: 10%;>'.$arrayPrecio[$i].'</td><td text-align: right; width: 10%;>'.$precioTot.'</td></tr>' ;
	
			}

			//plantilla usada
			$template_name = 'order_dev'; 
			//idioma, el 3 español
			$id_lang = 3;   
			$subject = 'Devolución Productos';
			$data = array(
					'{firstname}' => $firstname,
					'{lastname}' => $lastname,
					'{email}' => $email,
					'{shop_name}' => Configuration::get('PS_SHOP_NAME'),
					'{shop_url}' => Configuration::get('PS_SHOP_DOMAIN'),
					'{id_devolucion}' =>$id_devolucion,
					'{fecha}' =>$fecha,
					'{payment}' => $pago,
					'{total_prod}'=> $totalProd,
					'{total_price}' => $totalDev,
					'{importe_dev}' => $importeDev,
					'{productsHTML}'=> $tablaProductosHTML,
					'{direccion}' => $calle,
					'{codigopostal}' => $postcode,
					'{poblacion}' => $city,
					'{carrier}'=> $transportista,
					'{payment}' => $pago,
					'{total_price}' => $totalDev
					
				  );
			$fileAttachment = 'logo_mail.jpg';

   

			//enviamos el correo			
			$send = Mail::Send($id_lang, $template_name, Mail::l($subject, $id_lang), $data, $email, $firstname.' '.$lastname
					, NULL, NULL, $fileAttachment);
			
			//Envio de correo a NACEX

			if (($transportista=='NACEX') and ($correoNacex=='S')){

			//plantilla usada
			$template_name = 'order_dev_nacex'; 
			//idioma, el 3 español
			$id_lang = 3;   
			$subject = 'Recogida devolución Productos para Grandes Zapatos';
			$data = array(
					'{firstname}' => $firstname,
					'{lastname}' => $lastname,
					'{email}' => $email,
					'{shop_name}' => Configuration::get('PS_SHOP_NAME'),
					'{shop_url}' => Configuration::get('PS_SHOP_DOMAIN'),
					'{id_devolucion}' =>$id_devolucion,
					'{payment}' => $pago,
					'{fecha}' =>$fecha,
					'{productsHTML}'=> $tablaProductosHTML,
					'{total_prod}'=> $totalProd,
					'{total_price}' => $totalDev,
					'{importe_dev}' => $importeDev,
					'{direccion}' => $calle,
					'{codigopostal}' => $postcode,
					'{poblacion}' => $city,
					'{carrier}'=> $transportista,
					'{horarecogida}' => $horarecogida
					
				  );
			$fileAttachment = 'logo_mail.jpg';

			//enviamos el correo			
			$send = Mail::Send($id_lang, $template_name, Mail::l($subject, $id_lang), $data, $email, $firstname.' '.$lastname
					, NULL, NULL, $fileAttachment);
		}

	}
	public function setMedia()
	{
		if (Tools::getValue('ajax') != 'true')
		{
			parent::setMedia();
			Tools::addCSS(_THEME_CSS_DIR_.'history.css');
			Tools::addCSS(_THEME_CSS_DIR_.'addresses.css');
		}
	}
	
	public function displayHeader()
	{
		if (Tools::getValue('ajax') != 'true')
			parent::displayHeader();
	}

	public function displayContent()
	{
		
		global $currency;

		parent::displayContent();

		self::$smarty->assign(array(
			'currencySign' => $currency->sign,
			'currencyRate' => $currency->conversion_rate,
			'currencyFormat' => $currency->format,
			'currencyBlank' => $currency->blank,
		));

		self::$smarty->display(_PS_THEME_DIR_.'itemsdevueltos.tpl');
		
	}

	public function displayFooter()
	{
		if (Tools::getValue('ajax') != 'true')
			parent::displayFooter();
	}
}

